$(() => {
let selectedRowIndex = -1;
$('#action-add').dxSpeedDialAction({
label: 'Add row',
icon: 'add',
index: 1,
onClick() {
grid.addRow();
grid.deselectAll();
},
}).dxSpeedDialAction('instance');
const deleteSDA = $('#action-remove').dxSpeedDialAction({
icon: 'trash',
label: 'Delete row',
index: 2,
visible: false,
onClick() {
grid.deleteRow(selectedRowIndex);
grid.deselectAll();
},
}).dxSpeedDialAction('instance');
const editSDA = $('#action-edit').dxSpeedDialAction({
label: 'Edit row',
icon: 'edit',
index: 3,
visible: false,
onClick() {
grid.editRow(selectedRowIndex);
grid.deselectAll();
},
}).dxSpeedDialAction('instance');
const grid = $('#grid').dxDataGrid({
dataSource: employees,
showBorders: true,
keyExpr: 'ID',
selection: {
mode: 'single',
},
paging: {
enabled: false,
},
editing: {
mode: 'popup',
texts: {
confirmDeleteMessage: '',
},
},
onSelectionChanged(e) {
selectedRowIndex = e.component.getRowIndexByKey(e.selectedRowKeys[0]);
deleteSDA.option('visible', selectedRowIndex !== -1);
editSDA.option('visible', selectedRowIndex !== -1);
},
columns: [
{
dataField: 'Prefix',
caption: 'Title',
},
'FirstName',
'LastName',
{
dataField: 'Position',
width: 130,
}, {
dataField: 'StateID',
caption: 'State',
width: 125,
lookup: {
dataSource: states,
displayExpr: 'Name',
valueExpr: 'ID',
},
}, {
dataField: 'BirthDate',
dataType: 'date',
width: 125,
},
],
}).dxDataGrid('instance');
$('#direction').dxSelectBox({
dataSource: ['auto', 'up', 'down'],
inputAttr: { 'aria-label': 'Direction' },
value: 'auto',
onSelectionChanged(e) {
DevExpress.config({
floatingActionButtonConfig: directions[e.selectedItem],
});
DevExpress.ui.repaintFloatingActionButton();
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="js/dx.all.js?v=25.2.8"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="grid"></div>
<div id="action-add"></div>
<div id="action-remove"></div>
<div id="action-edit"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Direction:</span>
<div id="direction"></div>
</div>
</div>
</div>
</body>
</html>
#grid {
height: 500px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
const directions = {
auto: {
icon: 'rowfield',
shading: true,
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
up: {
icon: 'rowfield',
shading: true,
direction: 'up',
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
down: {
icon: 'rowfield',
shading: true,
direction: 'down',
position: {
of: '.dx-datagrid-rowsview',
my: 'right top',
at: 'right top',
offset: '-16 16',
},
},
};
const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
const states = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];

<dx-data-grid
id="grid"
[dataSource]="employees"
[showBorders]="true"
keyExpr="ID"
(onSelectionChanged)="selectedChanged($event)"
>
<dxo-data-grid-selection mode="single"></dxo-data-grid-selection>
<dxo-data-grid-paging [enabled]="false"></dxo-data-grid-paging>
<dxo-data-grid-editing mode="popup">
<dxo-data-grid-texts confirmDeleteMessage=""></dxo-data-grid-texts>
</dxo-data-grid-editing>
<dxi-data-grid-column
dataField="Prefix"
caption="Title"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="FirstName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="LastName"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Position"
[width]="130"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="StateID" [width]="125" caption="State">
<dxo-data-grid-lookup
[dataSource]="states"
displayExpr="Name"
valueExpr="ID"
></dxo-data-grid-lookup>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="BirthDate"
[width]="125"
dataType="date"
></dxi-data-grid-column>
</dx-data-grid>
<dx-speed-dial-action
icon="add"
label="Add row"
[index]="1"
(onClick)="addRow()"
>
</dx-speed-dial-action>
<dx-speed-dial-action
icon="trash"
label="Delete row"
[index]="2"
[visible]="selectedRowIndex !== -1"
(onClick)="deleteRow()"
>
</dx-speed-dial-action>
<dx-speed-dial-action
icon="edit"
label="Edit row"
[index]="3"
[visible]="selectedRowIndex !== -1"
(onClick)="editRow()"
>
</dx-speed-dial-action>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Direction: </span>
<dx-select-box
[dataSource]="['auto', 'up', 'down']"
value="auto"
[inputAttr]="{ 'aria-label': 'Direction' }"
(onSelectionChanged)="directionChanged($event)"
></dx-select-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import config from 'devextreme/core/config';
import repaintFloatingActionButton from 'devextreme/ui/speed_dial_action/repaint_floating_action_button';
import { DxSpeedDialActionModule } from 'devextreme-angular';
import { DxDataGridModule, DxDataGridComponent, DxDataGridTypes } from 'devextreme-angular/ui/data-grid';
import { DxSelectBoxModule, DxSelectBoxTypes } from 'devextreme-angular/ui/select-box';
import {
Service, Employee, State, directions,
} from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxDataGridModule,
DxSpeedDialActionModule,
DxSelectBoxModule,
],
})
export class AppComponent {
@ViewChild(DxDataGridComponent, { static: false }) grid: DxDataGridComponent;
employees: Employee[];
states: State[];
directions = directions;
selectedRowIndex = -1;
constructor(private service: Service) {
this.employees = service.getEmployees();
this.states = service.getStates();
}
editRow() {
this.grid.instance.editRow(this.selectedRowIndex);
this.grid.instance.deselectAll();
}
deleteRow() {
this.grid.instance.deleteRow(this.selectedRowIndex);
this.grid.instance.deselectAll();
}
addRow() {
this.grid.instance.addRow();
this.grid.instance.deselectAll();
}
selectedChanged(e: DxDataGridTypes.SelectionChangedEvent) {
this.selectedRowIndex = e.component.getRowIndexByKey(e.selectedRowKeys[0]);
}
directionChanged(e: DxSelectBoxTypes.SelectionChangedEvent) {
config({
floatingActionButtonConfig: this.directions[e.selectedItem],
});
repaintFloatingActionButton();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
#grid {
height: 500px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export const directions = {
auto: {
icon: 'rowfield',
shading: true,
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
up: {
icon: 'rowfield',
shading: true,
direction: 'up',
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
down: {
icon: 'rowfield',
shading: true,
direction: 'down',
position: {
of: '.dx-datagrid-rowsview',
my: 'right top',
at: 'right top',
offset: '-16 16',
},
},
};
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
StateID: number;
}
export class State {
ID: number;
Name: string;
}
const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
const states: State[] = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];
@Injectable()
export class Service {
getEmployees(): Employee[] {
return employees;
}
getStates(): State[] {
return states;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React, { useCallback, useRef, useState } from 'react';
import config from 'devextreme/core/config';
import repaintFloatingActionButton from 'devextreme/ui/speed_dial_action/repaint_floating_action_button';
import DataGrid, {
Column, Editing, Lookup, Texts, Selection,
} from 'devextreme-react/data-grid';
import { SpeedDialAction } from 'devextreme-react/speed-dial-action';
import { SelectBox } from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import type { DataGridTypes, DataGridRef } from 'devextreme-react/data-grid';
import {
employees, states, directions, optionDirections, directionLabel,
} from './data.ts';
import type { DirectionKey } from './data.ts';
const App = () => {
const [selectedRowIndex, setSelectedRowIndex] = useState(-1);
const gridRef = useRef<DataGridRef>(null);
const selectedChanged = useCallback((e: DataGridTypes.SelectionChangedEvent) => {
setSelectedRowIndex(e.component.getRowIndexByKey(e.selectedRowKeys[0]));
}, []);
const directionChanged = useCallback((e: SelectBoxTypes.SelectionChangedEvent) => {
config({
floatingActionButtonConfig: directions[e.selectedItem as DirectionKey],
});
repaintFloatingActionButton();
}, []);
const editRow = useCallback(() => {
gridRef.current?.instance()?.editRow(selectedRowIndex);
gridRef.current?.instance()?.deselectAll();
}, [selectedRowIndex]);
const deleteRow = useCallback(() => {
gridRef.current?.instance()?.deleteRow(selectedRowIndex);
gridRef.current?.instance()?.deselectAll();
}, [selectedRowIndex]);
const addRow = useCallback(() => {
gridRef.current?.instance()?.addRow();
gridRef.current?.instance()?.deselectAll();
}, []);
return (
<div>
<DataGrid
id="grid"
dataSource={employees}
keyExpr="ID"
ref={gridRef}
showBorders={true}
onSelectionChanged={selectedChanged}>
<Column dataField="Prefix" caption="Title" />
<Column dataField="FirstName" />
<Column dataField="LastName" />
<Column dataField="Position" width={130} />
<Column dataField="StateID" caption="State" width={125}>
<Lookup dataSource={states} valueExpr="ID" displayExpr="Name" />
</Column>
<Column dataField="BirthDate" dataType="date" width={125} />
<Selection mode="single" />
<Editing mode="popup">
<Texts confirmDeleteMessage="" />
</Editing>
</DataGrid>
<SpeedDialAction
icon="add"
label="Add row"
index={1}
onClick={addRow} />
<SpeedDialAction
icon="trash"
label="Delete row"
index={2}
visible={selectedRowIndex !== undefined && selectedRowIndex !== -1}
onClick={deleteRow} />
<SpeedDialAction
icon="edit"
label="Edit row"
index={3}
visible={selectedRowIndex !== undefined && selectedRowIndex !== -1}
onClick={editRow} />
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Direction: </span>
<SelectBox
dataSource={optionDirections}
defaultValue="auto"
inputAttr={directionLabel}
onSelectionChanged={directionChanged}
/>
</div>
</div>
</div>
);
};
export default App;
import React, { useCallback, useRef, useState } from 'react';
import config from 'devextreme/core/config';
import repaintFloatingActionButton from 'devextreme/ui/speed_dial_action/repaint_floating_action_button';
import DataGrid, {
Column, Editing, Lookup, Texts, Selection,
} from 'devextreme-react/data-grid';
import { SpeedDialAction } from 'devextreme-react/speed-dial-action';
import { SelectBox } from 'devextreme-react/select-box';
import {
employees, states, directions, optionDirections, directionLabel,
} from './data.js';
const App = () => {
const [selectedRowIndex, setSelectedRowIndex] = useState(-1);
const gridRef = useRef(null);
const selectedChanged = useCallback((e) => {
setSelectedRowIndex(e.component.getRowIndexByKey(e.selectedRowKeys[0]));
}, []);
const directionChanged = useCallback((e) => {
config({
floatingActionButtonConfig: directions[e.selectedItem],
});
repaintFloatingActionButton();
}, []);
const editRow = useCallback(() => {
gridRef.current?.instance()?.editRow(selectedRowIndex);
gridRef.current?.instance()?.deselectAll();
}, [selectedRowIndex]);
const deleteRow = useCallback(() => {
gridRef.current?.instance()?.deleteRow(selectedRowIndex);
gridRef.current?.instance()?.deselectAll();
}, [selectedRowIndex]);
const addRow = useCallback(() => {
gridRef.current?.instance()?.addRow();
gridRef.current?.instance()?.deselectAll();
}, []);
return (
<div>
<DataGrid
id="grid"
dataSource={employees}
keyExpr="ID"
ref={gridRef}
showBorders={true}
onSelectionChanged={selectedChanged}
>
<Column
dataField="Prefix"
caption="Title"
/>
<Column dataField="FirstName" />
<Column dataField="LastName" />
<Column
dataField="Position"
width={130}
/>
<Column
dataField="StateID"
caption="State"
width={125}
>
<Lookup
dataSource={states}
valueExpr="ID"
displayExpr="Name"
/>
</Column>
<Column
dataField="BirthDate"
dataType="date"
width={125}
/>
<Selection mode="single" />
<Editing mode="popup">
<Texts confirmDeleteMessage="" />
</Editing>
</DataGrid>
<SpeedDialAction
icon="add"
label="Add row"
index={1}
onClick={addRow}
/>
<SpeedDialAction
icon="trash"
label="Delete row"
index={2}
visible={selectedRowIndex !== undefined && selectedRowIndex !== -1}
onClick={deleteRow}
/>
<SpeedDialAction
icon="edit"
label="Edit row"
index={3}
visible={selectedRowIndex !== undefined && selectedRowIndex !== -1}
onClick={editRow}
/>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Direction: </span>
<SelectBox
dataSource={optionDirections}
defaultValue="auto"
inputAttr={directionLabel}
onSelectionChanged={directionChanged}
/>
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { FloatingActionButtonDirection, PositionAlignment } from 'devextreme-react/common';
type DirectionValue = {
icon: string;
shading: boolean;
direction?: FloatingActionButtonDirection;
position: {
of: string;
my: PositionAlignment;
at: PositionAlignment;
offset: string;
};
};
export const optionDirections = ['auto', 'up', 'down'] as const;
export type DirectionKey = typeof optionDirections[number];
export const directions: Record<DirectionKey, DirectionValue> = {
auto: {
icon: 'rowfield',
shading: true,
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
up: {
icon: 'rowfield',
shading: true,
direction: 'up',
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
down: {
icon: 'rowfield',
shading: true,
direction: 'down',
position: {
of: '.dx-datagrid-rowsview',
my: 'right top',
at: 'right top',
offset: '-16 16',
},
},
};
export const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
export const states = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];
export const directionLabel = { 'aria-label': 'Mode' };
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const optionDirections = ['auto', 'up', 'down'];
export const directions = {
auto: {
icon: 'rowfield',
shading: true,
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
up: {
icon: 'rowfield',
shading: true,
direction: 'up',
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
down: {
icon: 'rowfield',
shading: true,
direction: 'down',
position: {
of: '.dx-datagrid-rowsview',
my: 'right top',
at: 'right top',
offset: '-16 16',
},
},
};
export const employees = [
{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes:
'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
},
{
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes:
'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
},
{
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes:
'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
},
{
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes:
"Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
},
{
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes:
'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
},
{
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes:
"Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
},
{
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes:
'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
},
{
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes:
'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
},
{
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes:
'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
},
{
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes:
"If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
},
{
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes:
'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
},
{
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes:
"Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
},
{
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes:
'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
},
{
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes:
"Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
},
];
export const states = [
{
ID: 1,
Name: 'Alabama',
},
{
ID: 2,
Name: 'Alaska',
},
{
ID: 3,
Name: 'Arizona',
},
{
ID: 4,
Name: 'Arkansas',
},
{
ID: 5,
Name: 'California',
},
{
ID: 6,
Name: 'Colorado',
},
{
ID: 7,
Name: 'Connecticut',
},
{
ID: 8,
Name: 'Delaware',
},
{
ID: 9,
Name: 'District of Columbia',
},
{
ID: 10,
Name: 'Florida',
},
{
ID: 11,
Name: 'Georgia',
},
{
ID: 12,
Name: 'Hawaii',
},
{
ID: 13,
Name: 'Idaho',
},
{
ID: 14,
Name: 'Illinois',
},
{
ID: 15,
Name: 'Indiana',
},
{
ID: 16,
Name: 'Iowa',
},
{
ID: 17,
Name: 'Kansas',
},
{
ID: 18,
Name: 'Kentucky',
},
{
ID: 19,
Name: 'Louisiana',
},
{
ID: 20,
Name: 'Maine',
},
{
ID: 21,
Name: 'Maryland',
},
{
ID: 22,
Name: 'Massachusetts',
},
{
ID: 23,
Name: 'Michigan',
},
{
ID: 24,
Name: 'Minnesota',
},
{
ID: 25,
Name: 'Mississippi',
},
{
ID: 26,
Name: 'Missouri',
},
{
ID: 27,
Name: 'Montana',
},
{
ID: 28,
Name: 'Nebraska',
},
{
ID: 29,
Name: 'Nevada',
},
{
ID: 30,
Name: 'New Hampshire',
},
{
ID: 31,
Name: 'New Jersey',
},
{
ID: 32,
Name: 'New Mexico',
},
{
ID: 33,
Name: 'New York',
},
{
ID: 34,
Name: 'North Carolina',
},
{
ID: 35,
Name: 'Ohio',
},
{
ID: 36,
Name: 'Oklahoma',
},
{
ID: 37,
Name: 'Oregon',
},
{
ID: 38,
Name: 'Pennsylvania',
},
{
ID: 39,
Name: 'Rhode Island',
},
{
ID: 40,
Name: 'South Carolina',
},
{
ID: 41,
Name: 'South Dakota',
},
{
ID: 42,
Name: 'Tennessee',
},
{
ID: 43,
Name: 'Texas',
},
{
ID: 44,
Name: 'Utah',
},
{
ID: 45,
Name: 'Vermont',
},
{
ID: 46,
Name: 'Virginia',
},
{
ID: 47,
Name: 'Washington',
},
{
ID: 48,
Name: 'West Virginia',
},
{
ID: 49,
Name: 'Wisconsin',
},
{
ID: 50,
Name: 'Wyoming',
},
{
ID: 51,
Name: 'North Dakota',
},
];
export const directionLabel = { 'aria-label': 'Mode' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#grid {
height: 500px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}

<template>
<div>
<DxDataGrid
id="grid"
ref="gridRef"
:data-source="employees"
:selection="{ mode: 'single' }"
:show-borders="true"
key-expr="ID"
@selection-changed="selectedChanged"
>
<DxPaging :enabled="false"/>
<DxEditing mode="popup">
<DxTexts confirm-delete-message=""/>
</DxEditing>
<DxColumn
data-field="Prefix"
caption="Title"
/>
<DxColumn data-field="FirstName"/>
<DxColumn data-field="LastName"/>
<DxColumn
:width="130"
data-field="Position"
/>
<DxColumn
:lookup="lookup"
:width="125"
data-field="StateID"
caption="State"
/>
<DxColumn
:width="125"
data-field="BirthDate"
data-type="date"
/>
</DxDataGrid>
<DxSpeedDialAction
:on-click="addRow"
:index="1"
icon="add"
label="Add row"
/>
<DxSpeedDialAction
:visible="selectedRowIndex !== -1"
:on-click="deleteRow"
:index="2"
icon="trash"
label="Delete row"
/>
<DxSpeedDialAction
:visible="selectedRowIndex !== -1"
:on-click="editRow"
:index="3"
icon="edit"
label="Edit row"
/>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Direction: </span>
<DxSelectBox
:data-source="['auto', 'up', 'down']"
value="auto"
:input-attr="{ 'aria-label': 'Direction' }"
@selection-changed="directionChanged"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import config from 'devextreme/core/config';
import repaintFloatingActionButton from 'devextreme/ui/speed_dial_action/repaint_floating_action_button';
import {
DxDataGrid,
DxColumn,
DxPaging,
DxEditing,
DxTexts,
} from 'devextreme-vue/data-grid';
import DxSpeedDialAction from 'devextreme-vue/speed-dial-action';
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import { employees, states, directions } from './data.ts';
const gridRef = ref();
const lookup = {
dataSource: states,
displayExpr: 'Name',
valueExpr: 'ID',
};
const selectedRowIndex = ref(-1);
const grid = computed(() => gridRef.value.instance);
function selectedChanged(e: any) {
selectedRowIndex.value = e.component.getRowIndexByKey(e.selectedRowKeys[0]);
}
function directionChanged(e: DxSelectBoxTypes.SelectionChangedEvent) {
config({
floatingActionButtonConfig: directions[e.selectedItem],
});
repaintFloatingActionButton();
}
function addRow() {
grid.value.addRow();
grid.value.deselectAll();
}
function deleteRow() {
grid.value.deleteRow(selectedRowIndex.value);
grid.value.deselectAll();
}
function editRow() {
grid.value.editRow(selectedRowIndex.value);
grid.value.deselectAll();
}
</script>
<style>
#grid {
height: 500px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const directions: Record<string, any> = {
auto: {
icon: 'rowfield',
shading: true,
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
up: {
icon: 'rowfield',
shading: true,
direction: 'up',
position: {
of: '#grid',
my: 'right bottom',
at: 'right bottom',
offset: '-16 -16',
},
},
down: {
icon: 'rowfield',
shading: true,
direction: 'down',
position: {
of: '.dx-datagrid-rowsview',
my: 'right top',
at: 'right top',
offset: '-16 16',
},
},
};
export const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
export const states = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>